;Przykładowy program POOL, możesz go używać,
;modyfikować i rozpowszechniać na licencji GPL.
;Autorzy: R&D Independent Team
;Źródło: www.pool-rnd.com

;Funkcja przesuwająca żółwia o jeden krok:
; :p - pozycja obiektu, za którym ma podążać żółw
; :f - wsp. skalujący wielkość kroku
; :d - odległość od :p, której żółw zaczyna ruch "w tył".
to krok :p :f [:d 0]
  seth towards :p  ;ustaw żółwia w kierunku "do :p"
  let "s :f * ((distance :p) - :d) ;oblicz krok
  if abs :s > 0.01 [fd :s]         ;przesuń żółwia
end

;Funkcja-konstruktor żółwi (klasa POOL).
to model
  setxy random 100 random 100
  "f := 0.02 + runif :r
  (setpc 1000 * (:f - 0.02) / :r 40)
  pd

  to onsignalkrok ;krok na sygnał od żółwia #first
    (krok pos @ parent :f 80)
  end
end

wrap        ;"sklejone" przeciwległe krawędzie okna
penup       ;żółw #first nie rysuje
shared "r   ;parametr :r wspólny dla wszystkich żółwii
"r := 0.05

;100 żółwii podążających za żółwiem #first, utworzonych
;przy pomocy funkcji-klasy "model".
"u := (newturtles 100 $model)

;stoper - 50x na sekundę (czyli co 20 milisekund)
"t := timer [
  krok mousepos 0.04 ;przesuwa żółwia #first za myszą...
  signal "krok  ;...i wysyła sygnał do pozostałych żółwi
] 20

